package com.example.system.mapper;


import com.example.system.common.AiChat;
import org.apache.ibatis.annotations.Mapper;

import java.util.List;

/**
 * AI竞赛助手Mapper接口
 */
@Mapper
public interface AiChatMapper {

    /**
     * 插入会话记录
     *
     * @param aiChat 会话记录
     * @return 影响的行数
     */
    int insert(AiChat aiChat);

    /**
     * 根据会话ID查询会话记录
     *
     * @param chatId 会话ID
     * @return 会话记录
     */
    AiChat selectById(Long chatId);

    /**
     * 查询用户最近的会话记录
     *
     * @param userId 用户ID
     * @param limit 限制条数
     * @return 会话记录列表
     */
    List<AiChat> selectRecentByUserId(Long userId, int limit);
}
