package com.example.system.service;


import com.example.system.common.AiResult;
import com.example.system.dto.AiChatRequestDTO;
import com.example.system.common.AiChat;
import java.util.List;

/**
 * AI竞赛助手服务接口
 */
public interface AiChatService {

    /**
     * 与AI助手对话
     *
     * @param requestDTO 请求DTO
     * @return 对话结果
     */
    AiResult<String> chat(AiChatRequestDTO requestDTO);

    /**
     * 获取用户最近的会话记录
     *
     * @param userId 用户ID
     * @return 会话记录列表
     */
    AiResult<List<AiChat>> getRecentChats(Long userId);
}


